package de.fraunhofer.iem.dataprovider.taskManager.tasks

import org.eclipse.jgit.api.Git
import java.io.File


data class GitProject(val name: String, val uri: String)
class GitTask(
    override val type: TaskType,
    private val gitProject: GitProject,
    private val outputPath: String,
    private val responseChannel: suspend (task: ITask) -> Unit
): Task() {

    override suspend fun execute() {
        logger.info("Cloning ${gitProject.name}")

        val git: Git = Git.cloneRepository()
            .setURI(gitProject.uri)
            .setDirectory(
                File("/tmp/opencode/${gitProject.name}-${taskID}")) // TODO: add output path
            .call()
        git.close()
        responseChannel(DoneTask("Successfully cloned ${gitProject.name}"))
    }
}